#!/usr/local/bin/python

import dbhash, string, os.path
from Tkinter import *


class myDialog(tkSimpleDialog.Dialog) :

    def __init__(self, master, word, wordList, title=None, action="add"):
        self.wordList = wordList
        self.word = word
        self.action = action
        tkSimpleDialog.Dialog.__init__(self, master, title)

    def body(self, master):
        Label(master, text = "These pronunciations of the %s were found - \n still %s a word ?" % (self.word, self.action) ).pack(side=TOP)

        # frame_height = 300
        canvasfrm_width = 150
        fsb = Scrollbar(master, orient=VERTICAL, jump=1)
        canvas_frm = Canvas(master, height=100, width=150, yscrollcommand=fsb.set)

        bodyframe = Frame(canvas_frm)
        bodyframe.pack()
        canvas_frm.create_window(0,0, window = bodyframe, anchor=NW)

        for eachbrokenupword in self.wordList :
            b = Label(bodyframe, text=eachbrokenupword)
            b.pack(anchor=W)
        
        # canvas_frm.config(scrollregion=(0,0,canvasfrm_width,canvas_frm.winfo_height()))
        # canvas_frm.config(scrollregion=canvas_frm.bbox(ALL))
        fsb.config(command=canvas_frm.yview)
        fsb.pack(side=RIGHT, fill=Y, pady=5)
        canvas_frm.pack(expand=YES, fill=BOTH, pady=5)
        canvas_frm.config(scrollregion=(0,0,canvasfrm_width,len(self.wordList)*28))


        self.lift()
        self.update()

    def apply(self):
        self.result = self.v.get()






class dictGUI:

#  Graphical portion

    def __init__(self):
        

    def makewidgets(self):
        

#  action portion

    def openDicts(self):
        if ( os.path.exists('cmu_phoneme.dict') and os.path.exists('cmu_soundex.dict') ) :
            phonemedict = 'cmu_phoneme.dict'
            soundexdict = 'cmu_soundex.dict'
        elif ( os.path.exists('moby_phoneme.dict') and os.path.exists('moby_soundex.dict') ) :
            phonemedict = 'moby_phoneme.dict'
            soundexdict = 'moby_soundex.dict'
        else :
            # message to user
            tkMessageBox.showinfo('Dictionary missing', \
                "unable to find appropriate dictionary files")
            return ""
        self.phonemedict = dbhash.open(phonemedict, 'r')
        self.soundexdict = dbhash.open(soundexdict, 'r')

    def closeDicts(self):
        self.phonemedict.close()
        self.soundexdict.close()


    def convert(self, starttext, action):
        transCharTable = "                                       '     -                   ABCDEFGHIJKLMNOPQRSTUVWXYZ      ABCDEFGHIJKLMNOPQRSTUVWXYZ               S O           S O  Y                                AAAAAAACEEEEIIIIDNOOOOOOOUUUUYDSAAAAAAACEEEEIIIIONOOOOOOOUUUUUDU"
        word = string.translate(starttext, transCharTable) # remove foreign accents and other punctuation
        return word

    def getsoundexword(self, word, dict, soundict, master):
        # sxcode = soundex_b.get_soundex(word)
        sxcode = soundex_3.soundex(word)
        if soundict.has_key(sxcode): # we found something that sounds like it
            multi_check = string.split(soundict[sxcode], ";") # maybe several somethings
            d = mySoundexDialog(master, word, multi_check) # ask the user if they meant this/these word/s
            # master.wait_window(d.top)
            if d.result : # if it was one of the soundex words 
                d2 = getword(d.result, dict, master) # the word exists, find out how it is pronounced
                return d2# tell the program
            else : # the user rejected all the soundex words
                return None
        else: # it's not in the soundex dictionary
            return None

    def getuserword(word, master):
        import breakdowngui
        t = breakdowngui.breakdownDialog(master, word)
        wd = t.result
        if wd :
            wd = string.join(wd, " ")
        return wd




    def deleteword(self, word):
        # get the word supplied by the user


        # check if dictionary has word
        word = self.convert(word)
        self.openDicts()
        if self.phonemedict.has_key(word) : # arrr, we know this one, we thinks
            breakup_multi = self.phonemedict[word].split(";") # can it be pronounced more than one way ?
            if len(breakup_multi) > 1:
                # if more than one spelling, ask which variant
                d = myDialog(master, word, breakup_multi) # ask the user which one
                
            # doublecheck deletion
            check = tkMessageBox.showinfo("Are you sure ?", "Really delete this word ?")
            if check :
                # delete the word variant (delete entire record if this is the only variant)


                # check if a soundex entry exists, delete the soundex entry


        self.closeDicts()

    def addword(self, word, breakdown):
        # get the word supplied by the user


        # check if dictionary already has word
        self.openDicts()
        word = self.convert(word)
        if self.phonemedict.has_key(word) : # arrr, we know this one, we thinks
            breakup_multi = self.phonemedict[word].split(";") # can it be pronounced more than one way ?
            # show the variants existing, check they still want to add this word


            # else check that addition isn't a mispelling, show soundex equivalents


            # get the user breakdown of the word


            # add the word
            phonemedict[word] = phonemedict[word] + ";" + breakdown
        else:
            phonemedict[word] = breakdown
        # if it doesn't have a soundex entry, add one


        self.closeDicts()


    def finish(self):
        pass


if __name__ == "__main__" :
    root = Tk()
    d = dictGUI(root)

