#!/usr/local/bin/python

import time, ConfigParser, os.path, string

# convert to general class
class exportClass:
    
    def __init__(self, timephonemelist, transtablefile, outfilename) :
        self.translation_filename = transtablefile
        self.outfilename = outfilename
        self.speech = timephonemelist
        self.readtranslationfile()
        # generic export
        self.exportFunction()

#    def readtranslationfile(self) :
#        # print self.translation_file
#        self.translationtable = {}
#        t = ConfigParser.ConfigParser()
#        t.read(self.translation_filename)
#        for phoneme in t.options('Translations') :
#                self.translationtable[string.upper(phoneme)] = t.get('Translations', phoneme)
#        # self.translationtable[line[0]] = line[1]

    def readtranslationfile(self) :
        self.translationtable = {}
        MOTfile = open(self.translation_filename, "r")
        for line in MOTfile.readlines() :
            if string.strip(line) == '[Translations]' :  # cope with old-style translation files
                pass
            else:
                try:
                    DPSphoneme, userphoneme = string.split(line, ":", 1)
                    self.translationtable[string.upper(DPSphoneme)] = string.strip(userphoneme) # set up the translation table
                    # self.phonemekeys[string.strip(userphoneme)] = [] # setup the keyframes tables for each phoneme
                except ValueError:   # probably a blank line
                    pass
        MOTfile.close()

    def exportPamela(self):
        elementtime, elementphoneme = 0, 1
        for element in self.speech :
            # we've been handed speech as a sorted list of (timeframe, phoneme) pairs
            if element[elementphoneme] == 'end' :
                break # 
            frame = int(element[elementtime])
            if element[elementphoneme] in self.translationtable.keys() :
                # convert it to the user phoneme in the tranlation table
                userphoneme = self.translationtable[element[elementphoneme]]
            else:
                userphoneme = element[elementphoneme]
            self.outfile.write("%d %s\n" % (frame, userphoneme))

    def exportSwitch(self):
        self.outfile.write("MohoSwitch1\n")
        # proceed with pamela export
        self.exportPamela()    

    def exportFunction(self):
        self.outfile = open(self.outfilename, "w")
        if os.path.splitext(self.outfilename)[1] == ".prs":
            self.exportPamela()
        else:
            self.exportSwitch()
        self.outfile.close()

