#!/usr/local/bin/python

from Tkinter import *
from ScrolledText import *
import tkMessageBox
from tkFileDialog import *
import fileinput
import os.path

class MotEdit(Toplevel) :

    PhonemeLists = {
        "Magpie" : ["A", "B", "C", "Closed", "D", "E", "F", "G", "I", "K", "L", "M", "N", "O", 
            "P", "Q", "R", "S", "T", "TH", "U", "V", "W"],
        "PAMELA non-stressed" : ["AA", "AE", "AH", "AO", "AW", "AY",
            "B", "CH", "D", "DH", "EH", "ER", "EY",
            "F", "G", "HH", "IH", "IY", "JH",
            "K", "L", "M", "N", "NG", "OW", "OY", 
            "P", "R", "S", "SH", "T", "TH",
            "UH", "UW", "V", "W", "Y", "Z", "ZH"],
        "PAMELA" : [ "AA0", "AA1", "AA2", 
                                                "AE0", "AE1", "AE2", 
                                                "AH0", "AH1", "AH2", 
                                                "AO0", "AO1", "AO2", 
                                                "AW0", "AW1", "AW2", 
                                                "AY0", "AY1", "AY2", 
                                                "B", "CH", "D", "DH", 
                                                "EH0", "EH1", "EH2", 
                                                "ER0", "ER1", "ER2", 
                                                "EY0", "EY1", "EY2", 
                                                "F", "G", "HH", 
                                                "IH0", "IH1", "IH2", 
                                                "IY0", "IY1", "IY2", 
                                                "JH", "K", "L", "M", "N", "NG", 
                                                "OW0", "OW1", "OW2", 
                                                "OY0", "OY1", "OY2", 
                                                "P", "R", "S", "SH", "T", "TH",
                                                "UH0", "UH1", "UH2", 
                                                "UW0", "UW1", "UW2", 
                                                "V", "W", "Y", "Z", "ZH"
        ],
        "LipSync" : ["A I", "C D G K N R S TH Y Z", "E", "F V", "L", "M B P", "O", "U", "W Q", 
            "aa", "ar", "a", "ai", "ah", "I", "b", "ch", "d", "eh", "e", "f", "g", "h", "w", "ih", "i", "ge", 
            "c", "k", "l", "m", "ng", "n", "oi", "ow", "aw", "o", "oo", "ooh",
            "p", "r", "sh", "s", "th", "t", "uh", "ur", "v", "w", "u", "z", "zz", "er", "ach", "eu" ],
        "AM85" : ["A I", "C D G K N R S TH Y Z", "E", "F V", "L", "M B P", "O", "U", "W Q", 
            "aa", "ar", "a", "ai", "ah", "I", "b", "ch", "d", "eh", "e", "f", "g", "h", "w", "ih", "i", "ge", 
            "c", "k", "l", "m", "ng", "n", "oi", "ow", "aw", "o", "oo", "ooh",
            "p", "r", "sh", "s", "th", "t", "uh", "ur", "v", "w", "u", "z", "zz", "er", "ach", "eu" ],
        "Moby" : [ "&", "(@)", "A", "eI", "@", "-", "b", "tS", "d", "E", "i", "f", "g", "h", "hw", 
            "I", "aI", "dZ", "c", "k", "l", "m", "N", "n", "Oi", "AU", "O", "oU", "u", "U", "p", "r", 
            "S", "s", "T", "D", "t", "@r", "v", "w", "j", "Z", "z", "R", "x", "y", "Y" ]
    }

    def __init__(self, master=None, filename=None):
        Toplevel.__init__(self, master)
        self.main = master
        # if self.main.master != None: # Why ?
        #     self.main.master.withdraw()
        # self.main.withdraw()
        # self.overrideredirect(1)
        self.filename = filename
        self.copypastebuf = "" 
        self.makewidgets()
        if filename != None :
            self.openfile(filename)


    def makewidgets(self) :
        bar = Menu(self)

        filem = Menu(bar)
        filem.add_command(label="Open...", command=self.openfile)
        filem.add_command(label="Save as...", command=self.saveasfile)
        filem.add_command(label="Clear", command=self.clearfile)
        filem.add_separator()
        filem.add_command(label="Exit", command=self.destroy)
  
        templatem = Menu(filem)
        # templatem.add_command(label="New Magpie 0.9 Template", command=lambda self=self : self.fileTemplate('Magpie') )
        templatem.add_command(label="New PAMELA 0.1 Template", command=lambda self=self : self.fileTemplate('PAMELA') )
        # templatem.add_command(label="New PAMELA 1.0 non-stressed Template", command=lambda self=self : self.fileTemplate('PAMELA non-stressed') )
        # templatem.add_command(label="New LipSync 1.2 Template", command=lambda self=self : self.fileTemplate('LipSync') )
        # templatem.add_command(label="New A:M 8.5 Template", command=lambda self=self : self.fileTemplate('AM85') )

        editm = Menu(bar)
        editm.add_command(label="Copy", command=self.copyBuf)
        editm.add_command(label="Paste", command=self.pasteBuf)

#        helpm = Menu(bar)
#        helpm.add_command(label="About", command=self.about)

        filem.add_cascade(label="New Template", menu=templatem)

        bar.add_cascade(label="File", menu=filem)
        bar.add_cascade(label="Edit", menu=editm)
#        bar.add_cascade(label="Help", menu=helpm)
        self.config(menu=bar)

        f = Frame(self,width=512)
        f.pack(expand=1, fill=BOTH)

        self.st = ScrolledText(f,background="white")
        self.st.pack(side=LEFT, fill=BOTH, expand=1)
        # root.mainloop()

    def copyBuf(self):
        self.copypastebuf = self.st.selection_get()
        self.st.tag_remove(SEL, 1.0, END)

    def pasteBuf(self):
        self.st.insert(INSERT, self.copypastebuf)

    def openfile(self, oname=None): # N.B. inserts opened file after current text
        if not oname :
            oname = askopenfilename(filetypes=[("Motley translation files", "*.mot")])
        if oname:
            # empty scrolled text widget here ?
            for line in fileinput.input(oname):
                self.st.insert(END,line)


    def saveasfile(self):
        sname = asksaveasfilename(filetypes=[("Motley translation files", "*.mot")], initialdir=".", initialfile=self.filename)
        if sname:
            self.filename = sname
            self.savefile()

    # Exercise : 
    # There is a small bug in our implementation of tkeditor.py:  
    # when a file is saved, an additional blank line may appear at the end of the saved version.  
    # Find the bug and fix it. 

    def savefile(self):
        if self.filename :
            ofp = open(self.filename,"w")

            # ofp.write(self.st.get(1.0,END)) # bug here??
            temp = self.st.get(1.0,END)
            if temp[-2:] == "\n\n" :
                temp = temp[:-1]
            ofp.write(temp)

            ofp.flush()
            ofp.close()
        else:
            self.saveasfile()

    def clearfile(self):
        self.st.delete(1.0,END)

    def fileTemplate(self, appPhonemes) :
        self.clearfile()
        pl = END
        self.st.insert(pl,"[Translations]\n")
        for phoneme in self.PhonemeLists[appPhonemes] :
            self.st.insert(pl,phoneme+": \n")

#    def about(self):
#        tkMessageBox.showinfo("Tkeditor", "Simple tkeditor Version 0.1\n"
#            "Written 1999, Ivan Van Laningham\n"
#            "for the book Teach Yourself Python in 24 Hours\n"
#            "minor modifications 2001, Myles Strous")


def openeditor() :
    global myf
    # t = MockEdit(myf,"c:/junk/moho3.txt")
    # t = MotEdit(myf)
    t = MotEdit(myf, "sample_mp.mot")
    t.transient(myf)

if __name__ == "__main__" :
    root = Tk()
    myf = Frame(root)
    b = Button(myf, text="Open Editor", command=openeditor).pack()
    myf.pack()
    root.mainloop()
