#!/usr/local/bin/python

import Tkinter
from Tkinter import *
import tkMessageBox

import strings
strings = strings.messages
import glob # used for detecting all MOT files in this folder
import TVariable
from ScrolledText import *
# import ScrolledText
import os


class PAMELAgui(Frame):

    def __init__(self, parent=None):    # an extended frame
        Frame.__init__(self, parent)    # attach to upper level
        self.parent=parent
        # self.pack()                     # do superclass init
        self.contextmessage = {}
        self.createWidgets()            # attach frame/widgets
        self.parent.title("PAMELA")  # set window-manager info
        self.parent.iconname("PAMELA")   # label when iconified

    def createWidgets(self):
        self.makeMenuBar()
        self.makeStatusBar()
        self.makeTextBar()
        self.makeToolbar()

    def contextinfo(self, event) :
        if self.contextmessage.has_key(event.widget) :
            self.writeStatusBar(self.contextmessage[event.widget])
#        else:
#            self.writeStatusBar(self, `event.widget`)

    def makeTextBar(self) :
        self.textbar = Frame(self.parent)
        self.textbar.pack(side=BOTTOM, fill=X)
        # self.textlabel = Label(self.textbar, text="Sentence : ")
        # self.textlabel.pack()
        self.textentry = Entry(self.textbar,width=80)
        self.textentry.pack(fill=X, padx=5)
        self.contextmessage[self.textentry] = strings["Entry area for plain text to be phonetically analysed using Phonetic > Phonetic breakdown"]
        self.textentry.bind("<Enter>", self.contextinfo)

    def makeStatusBar(self):
        self.statusbar = Frame(self.parent)
        self.statusbar.pack(side=BOTTOM, fill=X, pady=5)
        self.status = Label(self.statusbar, text="Welcome", relief=SUNKEN)
        self.status.pack(side=BOTTOM, fill=X, padx=5)
        self.contextmessage[self.status] = strings["This is the status bar - it gives useful messages, hopefully"]
        self.status.bind("<Enter>", self.contextinfo)

    def writeStatusBar(self, stringtowrite):
        self.status.config(text=stringtowrite)
        self.status.update_idletasks()


    def makeToolbar(self):
        self.toolbar = Frame(self.parent)
        self.toolbar.pack(side=TOP, fill=X, pady=5)

        # option menu for choosing a phoneme
        PhonemeList = [
                "AA", "AE", "AH", "AO", "AW", "AY",
                "B", "CH", "D", "DH", "EH", "ER", "EY",
                "F", "G", "HH", "IH", "IY", "JH",
                "K", "L", "M", "N", "NG", "OW", "OY", 
                "P", "R", "S", "SH", "T", "TH",
                "UH", "UW", "V", "W", "Y", "Z", "ZH"
        ]
        self.phonemeToInsert = StringVar()
        self.phonemeToInsert.set(PhonemeList[0]) # default
        # the constructor syntax is:
        # OptionMenu(master, variable, *values)
        self.phonemechoice = apply(OptionMenu, (self.toolbar, self.phonemeToInsert) + tuple(PhonemeList))
        # self.phonemechoice = OptionMenu(self.toolbar, self.phonemeToInsert, tuple(PhonemeList))
        self.phonemechoice.pack(side=LEFT)

        # option menu for vowel phoneme stress
        StressList = [strings["Vowel - no stress"], strings["Vowel - primary stress"], strings["Vowel - secondary stress"]]
        self.phonemeStressToInsert = StringVar()
        self.phonemeStressToInsert.set(StressList[0]) # default
        self.phonemestresschoice = apply(OptionMenu, (self.toolbar, self.phonemeStressToInsert) + tuple(StressList))
        self.phonemestresschoice.pack(side=LEFT)

        Button(self.toolbar, text=strings["Insert phoneme"], command=self.insertphoneme__from_toolbar).pack(side=LEFT)



        Button(self.toolbar, text=strings["Preview"], command=self.playPreview).pack(side=RIGHT)

        # option menu for choosing MOT file (reset preferences)
        MOTlist = glob.glob("*.mot")
        self.currentMOTfile = TVariable.TStringVar()
        self.currentMOTfile.master=self.toolbar
        self.currentMOTfile.set(MOTlist[0]) # default
        # the constructor syntax is:
        # OptionMenu(master, variable, *values)
        # apply(function, args[, keywords]) 
        motmenu = apply(OptionMenu, (self.toolbar, self.currentMOTfile)+tuple( MOTlist))
        motmenu.pack(side=RIGHT)
        self.currentMOTfile.trace_write(self.newmot)



    def insertphoneme__from_toolbar(self):
        pass

    def newmot(self, nuMOTfile):
        pass

    def makeMenuBar(self):

# ===================================================
# ===================================================
# ===================================================

        menubar = Menu(self)

        filem = Menu(menubar)
        filem.add_command(label=strings["New project"], command=self.newProject)
        filem.add_command(label=strings['Open project'], command=self.openProject)
        filem.add_command(label=strings['Save project'], command=self.saveProject)
        filem.add_command(label=strings['Save project as'], command=self.saveProjectAs)
        filem.add_command(label=strings['Preferences'], command=self.preferences)
        filem.add_command(label=strings['Export Switch data'], command=self.exportAction)
        filem.add_command(label=strings['Import Switch data'], command=self.importSwitchFile)
        filem.add_command(label=strings['Quit'], command=self.quit)

        phoneticm = Menu(menubar)
        phoneticm.add_command(label=strings['Add phoneme'], command=self.insertphoneme)
        phoneticm.add_command(label=strings['Play entire WAV'], command=self.playWAV)
        phoneticm.add_command(label=strings['Play image preview'], command=self.playPreview)
        phoneticm.add_command(label=strings['Phonetic Breakdown'], command=self.phoneticBreakdown)
        phoneticm.add_command(label=strings['Simplified Breakdown'], command=self.simplifiedPhoneticBreakdown)
        phoneticm.add_command(label=strings['Spanish Breakdown'], command=self.spanishPhoneticBreakdown)
        phoneticm.add_command(label=strings['Simplified Spanish'], command=self.simplifiedSpanishPhoneticBreakdown)
        phoneticm.add_command(label=strings['Edit phoneme translation'], command=self.editphonemetranslation)
        # phoneticm.add_command(label=strings['Choose translation file'], command=self.choosemot)


        debugm = Menu(menubar)
        debugm.add_command(label='citems', command=self.debugcitems)
        debugm.add_command(label='timeitems', command=self.debugtimeitems)
        debugm.add_command(label='phonetictext', command=self.debugphonetictext)
        debugm.add_command(label='output', command=self.debugoutput)
        debugm.add_command(label='speech', command=self.debugspeech)
        debugm.add_command(label='frames', command=self.debugframes)

        helpm = Menu(menubar)
        helpm.add_command(label=strings['About'], command=self.helpAbout)
        helpm.add_command(label=strings['Tutorial'], command=self.helpTutorial)
        helpm.add_command(label=strings['Website'], command=self.helpWebsite)
        helpm.add_command(label=strings['Moho site'], command=self.mohoWebsite)
        helpm.add_command(label=strings['Phoneme list'], command=self.phonemelist)

        menubar.add_cascade(label=strings["File"], menu=filem)
        menubar.add_cascade(label=strings["Phonetic"], menu=phoneticm)
        menubar.add_cascade(label=strings["Help"], menu=helpm)
#        if __debug__ :
        # menubar.add_cascade(label="Debug", menu=debugm)

        self.parent.config(menu=menubar)

        # hmm, not working with new version of menu
#        self.contextmessage[menubar] = "The menubar - no keyboard shortcuts yet"
#        menubar.bind("<Enter>", self.contextinfo)
#        self.contextmessage[helpm] = "Help menu"
#        menubar.bind("<Enter>", self.contextinfo)
#        self.contextmessage[filem] = "File menu"
#        filem.bind("<Enter>", self.contextinfo)
#        self.contextmessage[phoneticm] = "Phonetic menu"
#        phoneticm.bind("<Enter>", self.contextinfo)
#


# ===================================================
# ===================================================
# ===================================================

# ------------------------------------------------------------------------


    def notimplemented(self) :
        tkMessageBox.showinfo("Not yet implemented","Not yet implemented")
        return

    def debugcitems(self) :
        pass

    def debugtimeitems(self) :
        pass

    def debugphonetictext(self) :
        pass

    def debugoutput(self) :
        pass

    def debugspeech(self) :
        pass

    def debugframes(self) :
        pass

# ------------------------------------------------------------------------

    def newProject(self) :
        pass

    def openProject(self) :
        pass

    def saveProject(self) :
        pass

    def saveProjectAs(self) :
        pass

    def preferences(self) :
        pass

# ---------------------------------------------------------------------------------

    def phoneticBreakdown(self) :
        pass

    def simplifiedPhoneticBreakdown(self) :
        pass

    def spanishPhoneticBreakdown(self) :
        pass

    def simplifiedSpanishPhoneticBreakdown():
        pass

    def insertphoneme(self) :
        pass

    def playWAV(self) :
        pass

    def playPreview(self) :
        pass

    def editphonemetranslation(self) :
        pass

    def exportAction(self) :
        pass

    def importSwitchFile(self) :
        pass


    def choosemot(self):
        pass

# -----------------------------------------------------------


    def helpAbout(self):
        tkMessageBox.showinfo(strings['About PAMELA'], \
        strings["PAMELA          by Myles Strous, myles.geo@yahoo.com\n\n"] +
        strings["a lip-synch aid \n"] +
        strings["for use with Lost Marble Moho (http://www.lostmarble.com/)\n\n"] +
        strings["uses the Carnegie Mellon University Pronouncing Dictionary\n\n"] +
        "Beta 0.3 April 2002") # this line has no language strings equivalent

    def helpTutorial(self):
        import webbrowser
        webbrowser.open(os.path.abspath('../tutorial/tutorial.html'))

    def helpWebsite(self):
        import webbrowser
        webbrowser.open('http://www.gippsland.monash.edu.au/~myles/catnap/pamela/index.html')

    def mohoWebsite(self):
        import webbrowser
        webbrowser.open('http://www.lostmarble.com/')
    

    def phonemelist(self):
        self.top = Tkinter.Toplevel(self)
        # make sure widget instances are deleted
        self.top.protocol("WM_DELETE_WINDOW", self.top.destroy)
        phoneme_list = """
    AA : odd  AA D, father F AA DH ER
    AE : at = AE T
    AH : hut = HH AH T
    AO : ought  AO T  hot dog HH AA T D AO G
    AW : cow = K AW
    AY : hide = HH AY D
    B : be = B IY
    CH : cheese = CH IY Z
    D : dee = D IY
    DH : thee = DH IY
    EH : Ed = EH D
    ER : hurt = HH ER T
    EY : ate = EY T
    F : fee = F IY
    G : green = G R IY N
    HH : he = HH IY
    IH : it = IH T
    IY : eat = IY T
    JH : gee = JH IY
    K : key = K IY
    L : lee = L IY
    M : me = M IY
    N : knee = N IY
    NG : ping = P IY NG
    OW : oat = OW T
    OY : toy = T OY
    P : pee = P IY
    R : read = R IY D
    S : sea = S IY
    SH : she = SH IY
    T : tea = T IY
    TH : theta = TH EY T AH
    UH : hood = HH UH D
    UW : two = T UW
    V : vee = V IY
    W : we = W IY
    Y : yield = Y IY L D
    Z : zee = Z IY
    ZH : seizure = S IY ZH ER
        """
        # self.textw = Tkinter.Text(self.top, width=40, height=40)
        self.textw = ScrolledText(self.top, width=40, height=42)
        self.textw.insert(Tkinter.END, phoneme_list)
        self.textw.pack()
        self.textw.config(state=DISABLED)

    def quit(self):
        pass

# -----------------------------------------------------------

if __name__ == '__main__' : 
    root = Tk()
    v = PAMELAgui(root)
    root.mainloop()
