#!/usr/local/bin/python

from Tkinter import *
import tkSimpleDialog, tkFileDialog
import string, base64
import pamfile
import strings
strings = strings.messages

def saveprefs(fps, fpp, translationfile):
        prefsdata = pamfile.pamfile()
        prefsdata['Preferences'] = {}
        prefsdata['Preferences']['framespersecond'] = fps
        prefsdata['Preferences']['framesperphoneme'] = fpp
        prefsdata['Preferences']['translationfile'] = translationfile
        # prefsfilename = './PAMELA.prf'
        prefsfilename = 'PAMELA.prf'
        prefsdata.save(prefsfilename)

class preferencesDialog(tkSimpleDialog.Dialog):

    def fps_decrement(self) :
        fps = string.atoi(self.fps.get())
        self.fps.delete(0,END)
        self.fps.insert(END, str(fps-1))

    def fps_increment(self) :
        fps = string.atoi(self.fps.get())
        self.fps.delete(0,END)
        self.fps.insert(END, str(fps+1))

    def fpp_decrement(self) : # frames per phoneme
        fpp = string.atoi(self.fpp.get())
        self.fpp.delete(0,END)
        self.fpp.insert(END, str(fpp-1))

    def fpp_increment(self) :
        fpp = string.atoi(self.fpp.get())
        self.fpp.delete(0,END)
        self.fpp.insert(END, str(fpp+1))


    # XXX remove ? (replaced by getmot)
    def changetranslation_file(self) : 
        newtranslation_file = tkFileDialog.askopenfilename(filetypes=[('Motley/PAMELA translation files', '*.mot')], initialdir=".")
        if newtranslation_file :
            self.translation_file_entry.delete(0,END)
            self.translation_file_entry.insert(END, newtranslation_file)

    def body(self,master) :

        leftarrow_img = "I2RlZmluZSBsZWZ0X3dpZHRoIDIzDQojZGVmaW5lIGxlZnRfaGVpZ2h0IDIzDQpzdGF0aWMgY2hh"\
        "ciBsZWZ0X2JpdHNbXSA9IHsNCiAweDAwLDB4MDAsMHg4MCwweDAwLDB4MDAsMHg4MCwweDAwLDB4"\
        "MDAsMHg4MCwweDAwLDB4MDAsMHg4MCwweDAwLDB4MDAsMHg4MCwNCiAweDAwLDB4MDAsMHg4MCww"\
        "eDAwLDB4MjAsMHg4MCwweDAwLDB4MzAsMHg4MCwweDAwLDB4MzgsMHg4MCwweDAwLDB4M2MsMHg4"\
        "MCwNCiAweDAwLDB4M2UsMHg4MCwweDAwLDB4M2YsMHg4MCwweDAwLDB4M2YsMHg4MCwweDAwLDB4"\
        "M2UsMHg4MCwweDAwLDB4M2MsMHg4MCwNCiAweDAwLDB4MzgsMHg4MCwweDAwLDB4MzAsMHg4MCww"\
        "eDAwLDB4MjAsMHg4MCwweDAwLDB4MDAsMHg4MCwweDAwLDB4MDAsMHg4MCwNCiAweDAwLDB4MDAs"\
        "MHg4MCwweDAwLDB4MDAsMHg4MCwweDAwLDB4MDAsMHg4MH07DQo="
        self.lbm = BitmapImage(data=base64.decodestring(leftarrow_img))

        rightarrow_img = "I2RlZmluZSByaWdodF93aWR0aCAyMw0KI2RlZmluZSByaWdodF9oZWlnaHQgMjMNCnN0YXRpYyBj"\
        "aGFyIHJpZ2h0X2JpdHNbXSA9IHsNCiAweDAwLDB4MDAsMHg4MCwweDAwLDB4MDAsMHg4MCwweDAw"\
        "LDB4MDAsMHg4MCwweDAwLDB4MDAsMHg4MCwweDAwLDB4MDAsMHg4MCwNCiAweDAwLDB4MDAsMHg4"\
        "MCwweDAwLDB4MDEsMHg4MCwweDAwLDB4MDMsMHg4MCwweDAwLDB4MDcsMHg4MCwweDAwLDB4MGYs"\
        "MHg4MCwNCiAweDAwLDB4MWYsMHg4MCwweDAwLDB4M2YsMHg4MCwweDAwLDB4M2YsMHg4MCwweDAw"\
        "LDB4MWYsMHg4MCwweDAwLDB4MGYsMHg4MCwNCiAweDAwLDB4MDcsMHg4MCwweDAwLDB4MDMsMHg4"\
        "MCwweDAwLDB4MDEsMHg4MCwweDAwLDB4MDAsMHg4MCwweDAwLDB4MDAsMHg4MCwNCiAweDAwLDB4"\
        "MDAsMHg4MCwweDAwLDB4MDAsMHg4MCwweDAwLDB4MDAsMHg4MH07DQo="
        self.rbm = BitmapImage(data=base64.decodestring(rightarrow_img))



        # self.prefsfilename = './PAMELA.prf'
        self.prefsfilename = 'PAMELA.prf'
        self.prefsdata = pamfile.pamfile(self.prefsfilename)
        # save current settings before attempting to modify them ??

        infps = string.atoi(self.prefsdata['Preferences']['framespersecond'])
        infpp = string.atoi(self.prefsdata['Preferences']['framesperphoneme'])
        in_translation_file = self.prefsdata['Preferences']['translationfile']
        # self.in_translation_file = self.prefsdata['Preferences']['translationfile'] # XXX repllaces above line


        Label(master, text=strings["Frames Per Second"]).grid(row=0, column=0)
        Button(master, image=self.lbm, command=self.fps_decrement).grid(row=0,column=1)
        self.fps = Entry(master, width=2)
        self.fps.insert(END,infps)
        self.fps.grid(row=0,column=2)
        Button(master, image=self.rbm, command=self.fps_increment).grid(row=0,column=3)

        Label(master, text=strings["Frames Per Phoneme"]).grid(row=1, column=0)
        Button(master, image=self.lbm, command=self.fpp_decrement).grid(row=1,column=1)
        self.fpp = Entry(master, width=2)
        self.fpp.insert(END,infpp)
        self.fpp.grid(row=1,column=2)
        Button(master, image=self.rbm, command=self.fpp_increment).grid(row=1,column=3)

        # XXX remove ? (replaced by getmot)
        Label(master, text=strings["Translation File"]).grid(row=2, column=0)
        Button(master, text=strings["Browse"], command=self.changetranslation_file).grid(row=2,column=1, columnspan=3)
        self.translation_file_entry = Entry(master, width=30)
        self.translation_file_entry.insert(END, in_translation_file)
        self.translation_file_entry.grid(row=3, column=0, columnspan=4)

    def apply(self) :
        fps = self.fps.get()
        fpp = self.fpp.get()
        translationfile = self.translation_file_entry.get() # XXX remove ? (replaced by getmot)
        # translationfile = self.in_translation_file

        self.prefsdata['Preferences']['framespersecond'] = fps
        self.prefsdata['Preferences']['framesperphoneme'] = fpp
        self.prefsdata['Preferences']['translationfile'] = translationfile

        self.prefsdata.save()

        self.result={'fps':int(fps), 'framesperphoneme':int(fpp), 'translation_file':translationfile}
        # self.result={'fps':int(fps), 'framesperphoneme':int(fpp)}


class test(Frame):

    def __init__(self, parent=None):    # an extended frame
        Frame.__init__(self, parent)    # attach to upper level
        self.pack()                     # do superclass init
        self.master.title("testprefgui")  # set window-manager info
        self.master.iconname("testprfgui")   # label when iconified
        self.b = Button(self, text="test", command=self.testbutton, bg="Moccasin")
        self.b.pack()

    def testbutton(self) :
        t = preferencesDialog(self)
        prefsokay = t.result
        if prefsokay :
            print 'Changed'
            print prefsokay
        else:
            print 'Cancelled'


if __name__ == '__main__' : 
    t = test()
    t.mainloop()
