#!/usr/local/bin/python

import string

def breakdowntext(sentence) :
    previous = ''
    breakdown_sentence = []
    words = string.split(string.lower(sentence))
    for word in words :
        if word == "_":
            breakdown_word = ["_"]
        else:
            previous = ''
            word_index = 0
            breakdown_word = []
            for letter in word :
                if letter == 'a' :
                    breakdown_word.append('AA0')
                elif letter == '' :
                    breakdown_word.append('AA1')
                elif letter == 'b' :
                    if word_index == 0 or previous in ['m', 'n']:
                        breakdown_word.append('B')
                    else :
                        breakdown_word.append('V')
                elif letter == 'c' :
                    if word_index < len(word)-1 and word[word_index+1]=='h' :
                        breakdown_word.append('CH')
                    elif previous == 'c' :
                        breakdown_word.append('S')
                    elif word_index < len(word)-1 and word[word_index+1]=='s' :
                        pass
                    elif word_index < len(word)-1 and word[word_index+1] in ['e', 'i'] :
                        # should this be SH before 'e', S before 'i' ??
                        breakdown_word.append('S')  # South American, Castilian Spanish uses 'TH'
                    else :
                        breakdown_word.append('K')
                elif letter == 'd' :
                    if word_index == 0 or previous in ['l', 'n']:
                        breakdown_word.append('D')
                    else :
                        breakdown_word.append('DH')
                elif letter == 'e' :
                    if word_index == len(word)-1 or word[word_index+1] in ['a','e','i','o','u'] :
                        breakdown_word.append('EY0')
                    else :
                        breakdown_word.append('EH0')
                elif letter == '' :
                    if word_index == len(word)-1 or word[word_index+1] in ['a','e','i','o','u'] :
                        breakdown_word.append('EY1')
                    else :
                        breakdown_word.append('EH1')
                elif letter == 'f' :
                    breakdown_word.append('F')
                elif letter == 'g' :
                    if word_index < len(word)-1 and word[word_index+1] == '' :
                        breakdown_word.append('V')
                    elif word_index < len(word)-1 and word[word_index+1] in ['e', 'i'] :
                        breakdown_word.append('HH')
                    else :
                        breakdown_word.append('G')
                elif letter == 'h' :
                    pass
                elif letter == 'i' :
                    breakdown_word.append('IY0')
                elif letter == '' :
                    breakdown_word.append('IY1')
                elif letter == 'j' :
                    breakdown_word.append('HH')
                elif letter == 'k' :
                    breakdown_word.append('K')
                elif letter == 'l' :
                    if word_index < len(word)-1 and word[word_index+1] == 'l' :
                        pass
                    elif previous == 'l' :
                        breakdown_word.append('Y')
                    else :
                        breakdown_word.append('L')
                elif letter == 'm' :
                    breakdown_word.append('M')
                elif letter == 'n' :
                    if word_index < len(word)-1 and word[word_index+1] == 'v' :
                        breakdown_word.append('M')
                    else :
                        breakdown_word.append('N')
                elif letter == '' :
                    breakdown_word.append('N')
                    breakdown_word.append('Y')
                elif letter == 'o' : 
                    if word_index < len(word)-1 and word[word_index+1] not in ['a','e','i','o','u']:  # last bit necessary ?
                        breakdown_word.append('AO0')
                    else :
                        breakdown_word.append('OW0')
                elif letter == '' :
                    if word_index < len(word)-1 and word[word_index+1] not in ['a','e','i','o','u']:  # last bit necessary ?
                        breakdown_word.append('AO1')
                    else :
                        breakdown_word.append('OW1')
                elif letter == 'p' :
                    if word_index == len(word)-1 :
                        pass
                    else :
                        breakdown_word.append('P')
                elif letter == 'q' :
                        breakdown_word.append('K')
                elif letter == 'r' :
                    if previous == 'r' :
                        pass
                    elif word_index < len(word)-1 and word[word_index+1] == 'r' :
                        breakdown_word.append('R') # RR - trilled a lot
                    else :
                        breakdown_word.append('R') # only a little trilled
                elif letter == 's' :
                    if word_index < len(word)-1 and word[word_index+1] in ['d','g','l','m','n'] :
                        breakdown_word.append('Z')
                    else:
                        breakdown_word.append('S')
                elif letter == 't' :
                    breakdown_word.append('T')
                elif letter == 'u' :
                    if previous == 'q' :
                        pass
                    elif previous == 'g' and word_index < len(word)-1 and word[word_index+1] in ['u','i'] :
                        pass
                    else :
                        breakdown_word.append('UW0')
                elif letter == '' :
                    if previous == 'q' :
                        pass
                    elif previous == 'g' and word_index < len(word)-1 and word[word_index+1] in ['u','i'] :
                        pass
                    else :
                        breakdown_word.append('UW1')
                elif letter == 'v' :
                    if word_index == 0 or previous in ['m', 'n']:
                        breakdown_word.append('B')
                    else :
                        breakdown_word.append('V')
                elif letter == 'w' :
                    breakdown_word.append('V')
                elif letter == 'x' :
                    if previous in ['a','e','i','o','u'] and word_index < len(word)-1 and word[word_index+1] in ['a','e','i','o','u'] :
                        breakdown_word.append('K')
                        breakdown_word.append('S')
                    else :
                        breakdown_word.append('S')
                elif letter == 'y' :
                    if len(word) == 1 :
                        breakdown_word.append('IY1')
                    elif word_index == len(word)-1 :
                        breakdown_word.append('IY0')
                    else :
                        breakdown_word.append('Y')
                elif letter == 'z' :
                    breakdown_word.append('S')  # South American, Castilian Spanish uses ''TH'
                previous = letter
                word_index = word_index + 1
            
            # add stress as necessary
            stressed = 0
            vowelcount = 0
            for phoneme in breakdown_word :
                if phoneme[-1] == '1' :
                    stressed = 1
                    break
                elif phoneme[-1] == '0' :
                    vowelcount =vowelcount + 1
            if not stressed :
                if vowelcount == 1 :
                    for n in range(len(breakdown_word)) :
                        if breakdown_word[n][-1] == '0' :
                            breakdown_word[n] = breakdown_word[n][:-1] + '1'
                            break
                elif breakdown_word[-1][0] not in ['A','E','I','O','U','Y','N','S'] :
                    for n in range(len(breakdown_word)-1, -1, -1) :
                        if breakdown_word[n][-1] == '0' :
                            breakdown_word[n] = breakdown_word[n][:-1] + '1'
                            break
                else :
                    tag = 0
                    for n in range(len(breakdown_word)-1, -1, -1) :
                        # print 'breakdown_word', breakdown_word, ', n : ', n
                        if breakdown_word[n][-1] == '0' :
                            if tag :
                                breakdown_word[n] = breakdown_word[n][:-1] + '1'
                                break
                            else :
                                tag = 1

        breakdown_sentence = breakdown_sentence + breakdown_word
    return breakdown_sentence

def simplifiedbreakdowntext(sentence):
    previous = ''
    brokenwords = []
    words = string.split(string.lower(sentence))
    for word in words :
        if word == "_":
            breakdown_word = ["_"]
        else:
            previous = ''
            word_index = 0
            breakdown_word = []
            for letter in word :
                if letter == 'a' :
                    breakdown_word.append('AA0')
                elif letter == '' :
                    breakdown_word.append('AA1')
                elif letter == 'b' :
                    if word_index == 0 or previous in ['m', 'n']:
                        breakdown_word.append('B')
                    else :
                        breakdown_word.append('V')
                elif letter == 'c' :
                    if word_index < len(word)-1 and word[word_index+1]=='h' :
                        breakdown_word.append('CH')
                    elif previous == 'c' :
                        breakdown_word.append('S')
                    elif word_index < len(word)-1 and word[word_index+1]=='s' :
                        pass
                    elif word_index < len(word)-1 and word[word_index+1] in ['e', 'i'] :
                        # should this be SH before 'e', S before 'i' ??
                        breakdown_word.append('S')  # South American, Castilian Spanish uses 'TH'
                    else :
                        breakdown_word.append('K')
                elif letter == 'd' :
                    if word_index == 0 or previous in ['l', 'n']:
                        breakdown_word.append('D')
                    else :
                        breakdown_word.append('DH')
                elif letter == 'e' :
                    if word_index == len(word)-1 or word[word_index+1] in ['a','e','i','o','u'] :
                        breakdown_word.append('EY0')
                    else :
                        breakdown_word.append('EH0')
                elif letter == '' :
                    if word_index == len(word)-1 or word[word_index+1] in ['a','e','i','o','u'] :
                        breakdown_word.append('EY1')
                    else :
                        breakdown_word.append('EH1')
                elif letter == 'f' :
                    breakdown_word.append('F')
                elif letter == 'g' :
                    if word_index < len(word)-1 and word[word_index+1] == '' :
                        breakdown_word.append('V')
                    elif word_index < len(word)-1 and word[word_index+1] in ['e', 'i'] :
                        breakdown_word.append('HH')
                    else :
                        breakdown_word.append('G')
                elif letter == 'h' :
                    pass
                elif letter == 'i' :
                    breakdown_word.append('IY0')
                elif letter == '' :
                    breakdown_word.append('IY1')
                elif letter == 'j' :
                    breakdown_word.append('HH')
                elif letter == 'k' :
                    breakdown_word.append('K')
                elif letter == 'l' :
                    if word_index < len(word)-1 and word[word_index+1] == 'l' :
                        pass
                    elif previous == 'l' :
                        breakdown_word.append('Y')
                    else :
                        breakdown_word.append('L')
                elif letter == 'm' :
                    breakdown_word.append('M')
                elif letter == 'n' :
                    if word_index < len(word)-1 and word[word_index+1] == 'v' :
                        breakdown_word.append('M')
                    else :
                        breakdown_word.append('N')
                elif letter == '' :
                    breakdown_word.append('N')
                    breakdown_word.append('Y')
                elif letter == 'o' : 
                    if word_index < len(word)-1 and word[word_index+1] not in ['a','e','i','o','u']:  # last bit necessary ?
                        breakdown_word.append('AO0')
                    else :
                        breakdown_word.append('OW0')
                elif letter == '' :
                    if word_index < len(word)-1 and word[word_index+1] not in ['a','e','i','o','u']:  # last bit necessary ?
                        breakdown_word.append('AO1')
                    else :
                        breakdown_word.append('OW1')
                elif letter == 'p' :
                    if word_index == len(word)-1 :
                        pass
                    else :
                        breakdown_word.append('P')
                elif letter == 'q' :
                        breakdown_word.append('K')
                elif letter == 'r' :
                    if previous == 'r' :
                        pass
                    elif word_index < len(word)-1 and word[word_index+1] == 'r' :
                        breakdown_word.append('R')  # RR - trilled a lot
                    else :
                        breakdown_word.append('R')  # trilled only a little
                elif letter == 's' :
                    if word_index < len(word)-1 and word[word_index+1] in ['d','g','l','m','n'] :
                        breakdown_word.append('Z')
                    breakdown_word.append('S')
                elif letter == 't' :
                    breakdown_word.append('T')
                elif letter == 'u' :
                    if previous == 'q' :
                        pass
                    elif previous == 'g' and word_index < len(word)-1 and word[word_index+1] in ['u','i'] :
                        pass
                    else :
                        breakdown_word.append('UW0')
                elif letter == '' :
                    if previous == 'q' :
                        pass
                    elif previous == 'g' and word_index < len(word)-1 and word[word_index+1] in ['u','i'] :
                        pass
                    else :
                        breakdown_word.append('UW1')
                elif letter == 'v' :
                    if word_index == 0 or previous in ['m', 'n']:
                        breakdown_word.append('B')
                    else :
                        breakdown_word.append('V')
                elif letter == 'w' :
                    breakdown_word.append('V')
                elif letter == 'x' :
                    if previous in ['a','e','i','o','u'] and word_index < len(word)-1 and word[word_index+1] in ['a','e','i','o','u'] :
                        breakdown_word.append('K')
                        breakdown_word.append('S')
                    else :
                        breakdown_word.append('S')
                elif letter == 'y' :
                    if len(word) == 1 :
                        breakdown_word.append('IY1')
                    elif word_index == len(word)-1 :
                        breakdown_word.append('IY0')
                    else :
                        breakdown_word.append('Y')
                elif letter == 'z' :
                    breakdown_word.append('S')  # South American, Castilian Spanish uses ''TH'
                previous = letter
                word_index = word_index + 1
            
            # add stress as necessary
            stressed = 0
            vowelcount = 0
            for phoneme in breakdown_word :
                if phoneme[-1] == '1' :
                    stressed = 1
                    break
                elif phoneme[-1] == '0' :
                    vowelcount =vowelcount + 1
            if not stressed :
                if vowelcount == 1 :
                    for n in range(len(breakdown_word)) :
                        if breakdown_word[n][-1] == '0' :
                            breakdown_word[n] = breakdown_word[n][:-1] + '1'
                            break
                elif breakdown_word[-1][0] not in ['A','E','I','O','U','Y','N','S'] :
                    for n in range(len(breakdown_word)-1, -1, -1) :
                        if breakdown_word[n][-1] == '0' :
                            breakdown_word[n] = breakdown_word[n][:-1] + '1'
                            break
                else :
                    tag = 0
                    for n in range(len(breakdown_word)-1, -1, -1) :
                        # print 'breakdown_word', breakdown_word, ', n : ', n
                        if breakdown_word[n][-1] == '0' :
                            if tag :
                                breakdown_word[n] = breakdown_word[n][:-1] + '1'
                                break
                            else :
                                tag = 1

        brokenwords.append(breakdown_word)

    # brokenwords is now a list of phoneme-listed words in phonetic format

    # primary and secondary emphasis, MBP, FV, WQ
    significant_phonemes = [
        "AA1", "AA2", 
        "AE1", "AE2", 
        "AH1", "AH2", 
        "AO1", "AO2", 
        "AW1", "AW2", 
        "AY1", "AY2", 
        "B",
        "EH1", "EH2", 
        "ER1", "ER2", 
        "EY1", "EY2", 
        "F",
        "IH1", "IH2", 
        "IY1", "IY2", 
        "M",
        "OW1", "OW2", 
        "OY1", "OY2", 
        "P",
        "UH1", "UH2", 
        "UW1", "UW2", 
        "V", "W", 
        "_"
    ]

    fullbreakdown = []
    for eachword in brokenwords :
        fullbreakdown.append(eachword[0])
        if len(eachword) > 1:
            for phoneme in eachword[1:-1] :
                if phoneme in significant_phonemes:
                    fullbreakdown.append(phoneme)
            fullbreakdown.append(eachword[-1])

    return fullbreakdown


PHONESET = ( "AA", "AE", "AH", "AO", "AW", "AY",
    "B", "CH", "D", "DH", "EH", "ER", "EY",
    "F", "G", "HH", "IH", "IY", "JH",
    "K", "L", "M", "N", "NG", "OW", "OY", 
    "P", "R", "S", "SH", "T", "TH",
    "UH", "UW", "V", "W", "Y", "Z", "ZH"
    )


if __name__ == '__main__' :
    print breakdowntext('Holas amigos y espaol _ _ padr')
    print simplifiedbreakdowntext('Holas amigos y _ _ espaol padre')
    # print spanish_breakdown("Selecciones de la semana Los mejores sitios")
    # print spanish_breakdown("los derechos humanos en amrica latina y")
